#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "stdio.h"
#include "gp2x_hacks.h"

#define SYS_CLK_FREQ 7372800
// system registers
static struct
{
        unsigned short SYSCLKENREG,SYSCSETREG,FPLLVSETREG,DUALINT920,DUALINT940,DUALCTRL940,DISPCSETREG;
}
system_reg;

//volatile unsigned short *MEM_REG;
unsigned MDIV,PDIV,SCALE;
volatile unsigned *arm940code;
//static int fclk;
static int cpufreq;
static Uint32 tvoutfix_sav;
static char name[256];


int hack_the_mmu(void) 
{
	int mmufd = open("/dev/mmuhack", O_RDWR);
	volatile unsigned int *secbuf = (unsigned int *)malloc (204800);
    if(mmufd < 0) 
	{
		system("/sbin/insmod -f mmuhack.o");
        mmufd = open("/dev/mmuhack", O_RDWR);
    }
    if(mmufd < 0) 
	{
		return 1;
	}
	
    close(mmufd);

    return 0;
}


/*
  void cpuctrl_init()
  {
  MEM_REG=&gp2x_memregs[0];
  }*/

void set_FCLK(unsigned MHZ)
{
        unsigned v;
        unsigned mdiv,pdiv=3,scale=0;
        MHZ*=1000000;
        mdiv=(MHZ*pdiv)/SYS_CLK_FREQ;
        //printf ("Old value = %04X\r",MEM_REG[0x924>>1]," ");
        //printf ("APLL = %04X\r",MEM_REG[0x91A>>1]," ");
        mdiv=((mdiv-8)<<8) & 0xff00;
        pdiv=((pdiv-2)<<2) & 0xfc;
        scale&=3;
        v=mdiv | pdiv | scale;
        gp2x_memregs[0x910>>1]=v;
}

unsigned get_FCLK()
{
        return gp2x_memregs[0x910>>1];
}

unsigned get_freq_920_CLK()
{
        unsigned i;
        unsigned reg,mdiv,pdiv,scale;
        reg=gp2x_memregs[0x912>>1];
        mdiv = ((reg & 0xff00) >> 8) + 8;
        pdiv = ((reg & 0xfc) >> 2) + 2;
        scale = reg & 3;
        MDIV=mdiv;
        PDIV=pdiv;
        SCALE=scale;
        i = (gp2x_memregs[0x91c>>1] & 7)+1;
        return ((SYS_CLK_FREQ * mdiv)/(pdiv << scale))/i;
}
unsigned short get_920_Div()
{
        return (gp2x_memregs[0x91c>>1] & 0x7);
}

void gp2x_video_RGB_setscaling(int W, int H)
{
#if 1
/*
	printf("Some TV out Regs\n");
	printf("TV-Out?       %04x\n",gp2x_memregs[0x2800>>1]&0x100);
	printf("horizontal    %04x\n",gp2x_memregs[0x2906>>1]);
	printf("vertical      %08x\n",gp2x_memregl[0x2908>>2]);
	printf("RGB Width     %04x\n",gp2x_memregs[0x290C>>1]);
	printf("RGB Windows   %04x\n",gp2x_memregs[0x28E2>>1]);
	printf("MLC_DPC_X_MAX %04x\n",gp2x_memregs[0x2816>>1]);
	printf("MLC_DPC_Y_MAX %04x\n",gp2x_memregs[0x2818>>1]);
	// C000 28E4h / C000 28ECh / C000 28F4h / C000 28FCh

	printf("STL1 ENDX     %04x\n",gp2x_memregs[0x28E4>>1]);
	printf("STL2 ENDX     %04x\n",gp2x_memregs[0x28EC>>1]);
	printf("STL3 ENDX     %04x\n",gp2x_memregs[0x28F4>>1]);
	printf("STL4 ENDX     %04x\n",gp2x_memregs[0x28FC>>1]);
*/
	//gp2x_memregs[0x28E4>>1]=gp2x_memregs[0x290C>>1];

	//gp2x_memregs[0x290C>>1]*=2;
#else
 float escalaw,escalah;
 int bpp=(gp2x_memregs[0x28DA>>1]>>9)&0x3;

 if(gp2x_memregs[0x2800>>1]&0x100) //TV-Out
 {
   escalaw=489.0; //RGB Horiz TV (PAL, NTSC)
   if (gp2x_memregs[0x2818>>1]  == 287) //PAL
     escalah=274.0; //RGB Vert TV PAL
   else if (gp2x_memregs[0x2818>>1]  == 239) //NTSC
     escalah=331.0; //RGB Vert TV NTSC
 }
 else //LCD
 {
   escalaw=1024.0; //RGB Horiz LCD
   escalah=320.0; //RGB Vert LCD
 }

 // scale horizontal
 gp2x_memregs[0x2906>>1]=(unsigned short)((float)escalaw *(W/320.0));
 // scale vertical
 gp2x_memregl[0x2908>>2]=(unsigned long)((float)escalah *bpp *(H/240.0));

#endif
}

//volatile Uint32 *gp2x_ram;
void gp2x_ram_init(void) {
	if(!gp2x_dev_mem) gp2x_dev_mem = open("/dev/mem",   O_RDWR);
	gp2x_ram=(Uint8 *)mmap(0, 0x1000000, PROT_READ|PROT_WRITE, MAP_SHARED, 
				gp2x_dev_mem, 0x02000000);
	gp2x_ram2=(Uint8 *)mmap(0, 0x1000000, PROT_READ|PROT_WRITE, MAP_SHARED, 
				gp2x_dev_mem, 0x03000000);
	//printf("gp2x_ram %p\n",gp2x_ram);
	gp2x_memregl=(Uint32 *)mmap(0, 0x10000, PROT_READ|PROT_WRITE, MAP_SHARED, 
				    gp2x_dev_mem, 0xc0000000);
	gp2x_memregs=(Uint16*)gp2x_memregl ;
}


void gp2x_sound_volume(int l, int r) {
	static int L;
	L=(((l*0x50)/100)<<8)|((r*0x50)/100);          //0x5A, 0x60
	ioctl(gp2x_mixer, SOUND_MIXER_WRITE_PCM, &L); //SOUND_MIXER_WRITE_VOLUME
}

void gp2x_set_cpu_speed(int overclock) 
{
	//int overclock=CF_VAL(cf_get_item_by_name("cpu_speed"));
	char clockgen = 0;
    unsigned sysfreq=0;

	/* save FCLOCK */
	sysfreq=get_freq_920_CLK();
    sysfreq*=get_920_Div()+1;
    cpufreq=sysfreq/1000000;

	// if the CPU speed is currently less than 250MHz, ramp it up.
	// yes, it's evil, but it'll do for now
	if (overclock!=0 && cpufreq < 250) {
		if (overclock<66) overclock=66;
		if (overclock>320) overclock=320;
		set_FCLK(overclock);
	}
}

void gp2x_quit(void) {
	
	if (gp2x_dev_mem!=-1) close(gp2x_dev_mem);
	//if (gp2x_gfx_dump!=-1) close(gp2x_gfx_dump);
	if (gp2x_mixer!=-1) close(gp2x_mixer);

	if (cpufreq < 250)
		set_FCLK(cpufreq);

	sync();
	//SDL_Quit();
	//gp2x_video_RGB_setscaling(0,0);
}


void gp2x_init_mixer(void) {
	//if (CF_BOOL(cf_get_item_by_name("sound"))) {
		gp2x_mixer=open("/dev/mixer", O_RDWR);
		if (gp2x_mixer==-1) {
			printf("Can't open mixer\n");
		}
	//}	
}

void gp2x_init(void) 
{
	volatile unsigned int *secbuf = (unsigned int *)malloc (204800);

	gp2x_ram_init();

	/* Fix tvout */
	tvoutfix_sav=gp2x_memregs[0x28E4>>1];
	gp2x_memregs[0x28E4>>1]=gp2x_memregs[0x290C>>1];
}



