/****************************************************************************/
/*                               Beebem                                     */
/*                               ------                                     */
/* This program may be distributed freely within the following restrictions:*/
/*                                                                          */
/* 1) You may not charge for this program or for any part of it.            */
/* 2) This copyright message must be distributed with all copies.           */
/* 3) This program must be distributed complete with source code.  Binary   */
/*    only distribution is not permitted.                                   */
/* 4) The author offers no warrenties, or guarentees etc. - you use it at   */
/*    your own risk.  If it messes something up or destroys your computer   */
/*    thats YOUR problem.                                                   */
/* 5) You may use small sections of code from this program in your own      */
/*    applications - but you must acknowledge its use.  If you plan to use  */
/*    large sections then please ask the author.                            */
/*                                                                          */
/* If you do not agree with any of the above then please do not use this    */
/* program.                                                                 */
/****************************************************************************/
/* Mike Wyatt and NRM's port to win32 - 7/6/97 */


/*

	expential sound on/off	IDM_EXPVOLUME



beebem 0.0.8:
-------------

01)Done	Dialog box support (basic support only).
02)Done	Create Message box and MFC wrapper.
03)Done	Create a 'poll' event every 10ms (or whenever BeebEm polls the GUI).

04)Done	Slide bar widget. (Need to add keyboard support for movement).
05)Done	Tabber widget (fudged).

06)Done	Toggle button widget.
07)Done	Simple progress bar widget.

09)Done	FDC options move to 'System'.
10)Done	Tube and Econet options move to 'Devices'.
11)Done	Better 'About' page.

12)Done	Remove dependancy for GTK - reads the filename already selected instead.

16)Done	Make EG a static link library and link it in.

18)Done	Change fullscreen so recreates 'screen' so no longer X11 dependant.

19)Done	Change rendering to support:
	640x512_scale, 640x512_grille, 640x480_scale, 640x480_offset,
	320x240_scale, 320x256_offset.

	(Each BBC mode can select one or other of the above. If width is 320,
	then teletext is in half mode, graphics is in half mode (but mode 0
	will still work).

19)Done	Fix horizontal offset when screen width changes in 320 modse

20)Done	Fix scaling to use table instead of math.

20)Done	Fix cursor for low res.

21)Done	Fix teletext vertical scaling for 480/240.

21)Done	Make sure menus are centred

22)	Update dialog text.

25)Done	Move Disks back to Disks

26)Done	Make sure Grille mode switches without leaving a mess.

27)Done	Add resolution toggles to screen menu.

28)Done	Make sure message boxes and dialog boxes are centred in all resolutions

29)Done	Disabke Grille teletext when 240 height



New rendering resolutions.



To be determined:
-----------------

*	debug.h/debug.cpp needs to be updated to version 3.3

*	Fix that teletext offset problem.

*	Remove some of the debugging output for econet.

*	Add progress bar to copy (it can jump in one go).

*	Fix the cursor offset (just move it up two lines).

*	New mouse cursor for emulator (halfsize one when .5 scale).

*	Change user interface to use nice tabs instead of seperate pages for
	most things.

*	File selectors on 'Disks' page (just simple ones like Hatari).

*	Have one surface that we render to directly (the screen), it should be
	in display color depth (will require major work on video.cpp
*	Make sure unchanged scanlines are not redrawn, this should be optional (some sort of {colection of}
	checksum{s}?).

*	Move focus Left, Right, Up and Down control - simple extention to widget.c.

*	Change from calculating GUI palette colours to definitions that say
	which colors to use and update the actual palette.

*	Support for 'merged' displays, i.e.: video emulation does not render over 'gui pages' [1].
*	The cursor IS off by two pixels! But how to fix it? (Investigate whole cursor emulation).
*	Moton blur? (Should get this free with video changes).
*	Finish fullscreen toggle support (need to recreate whole window when changing).
*	Improve on that crappy FPS on-screen monitor (at least get it to scale properly).
*	Teletext rendering starts on scanline -2, why?

*	Better keyboard mapping: Create spreadsheet and map all keys correctly, look at ver 0.9
*	Serial + tape support (threading).


*	Have toggle-able 'Quick' menu for usual stuff.

*	Programmable keyboard/joystick support for movement within the GUI, for changing focus and the slide bar.

*	Clean-up main.cpp.
*	Make sure all output goes through log.
*	Give output messages (debug, error, warning etc) a once over.
*	Some basic documentation to get people started.
*	Search for and fix any outstanding FIX-MEs or TODOs.
*	Installing/Building documentation.

*	Investigate YUV support (Dave Gilbert's 'fast table' should make this quite easy to implement for 12bit).

[1]:	The emulator should use less processing power to maintain the menus than it does to render the video
	window, so why not have the emulator running while the gui is displayed?  Just basic support here,
	0.0.10 (with the new GUI) will have full support.


*	New GUI.
*	Software abstraction layer between MFC emulation and new GUI.
*	Experiential GTK GUI support.
*	Add save audio option.
*	Investigate video recording options.
*	Test Speech.
*	Image widget (needs to be scalable).
*	(What else goes in devices?)
*	User keyboard dialog? (to be determined).
*	Debugging dialog? (to be determined).
*	Fix design issues with GUI (to be determined).
*	Add bitmapped widgets + image support (for the Beeb menu background).
*	Vertical screen position in Castle Quest, is this a bug?
*	Update website for offical production release.
*	Keyboard mapper.
*	Debugger.

*/

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include <SDL.h>
#include <SDL_keysym.h>
#include <SDL_image.h>
#include <dirent.h>
#include "SFont.h"

#include <iostream>
#include <fstream>
#include "windows.h"

#include "6502core.h"
#include "beebmem.h"
#include "beebsound.h"
#include "sysvia.h"
#include "uservia.h"
#include "beebwin.h"
#include "disc8271.h"
#include "video.h"
#include "via.h"
#include "atodconv.h"
#include "disc1770.h"
#include "serial.h"
#include "tube.h"
#include "econet.h"	//Rob

#include "scsi.h"	// Dave: Needed for reset on break
#include "sasi.h"

#include "i86.h"
#include "teletext.h"
#include "z80mem.h"
#include "z80.h"

#include "line.h"	// SDL Stuff
#include "log.h"
#include "sdl.h"

#include "gp2x.h"
//#include <gui.h>

//#include "beebem_pages.h"
#include "fake_registry.h"

// Can remove this (only needed to calc string hash)
//#include <gui_functions.h>


#ifdef MULTITHREAD
#undef MULTITHREAD
#endif

/* Make global reference to command line args
 */
int __argc = 0;
char **__argv = NULL;

/* This needs to be fixed.. ----
 */
int Tmp_Command_Line_Fullscreen=0;
/* -----------------------------
 */

//+>
	// Load/Save path.
	extern char *cfg_LoadAndSavePath_ptr;
//<+


extern int TorchTube;
extern int Enable_Z80;
extern VIAState SysVIAState;
extern int	cfg_WantLowLatencySound;
int DumpAfterEach=0;

unsigned char MachineType;
BeebWin *mainWin = NULL;

SFont_Font* menuWhiteFont;
SFont_Font* menuYellowFont;
SDL_Surface* menuSurface;
SDL_Surface* banner;

extern int gp2x_mapping[9][2];
char* SDLKToKeyname(int sdlk);

void i86_main(void);

//-- HINSTANCE hInst;
//-- HWND hCurrentDialog = NULL;

//-- DWORD iSerialThread,iStatThread; // Thread IDs
FILE *tlog;


//----------------------------------------------

int done = 0;
int fullscreen = 0;
int showing_menu = 0;

const int MAX_ROM_COUNT = 1024;
char* g_rom_list [MAX_ROM_COUNT];
int g_selected_rom_ix = 0;
int g_rom_count = 0;
int g_selected_line = 0;
int MenuSoundEnabled = 0;

char*	g_keymap_list [MAX_ROM_COUNT];
int		g_selected_keymap_ix = 0;
int		g_keymap_count = 0;

const int MENU_LINE_COUNT = 6;

const int MENU_LINE_SOUND = 0;
const int MENU_LINE_FRAMESKIP = 1;
const int MENU_LINE_KEYMAP = 2;
const int MENU_LINE_STATE = 3; 
const int MENU_LINE_ROM_SELECTOR = 4;
const int MENU_LINE_QUIT = 5;

const int MENU_LINE_HEIGHT = 38;

void PopulateKeymapList()
{
	char keymapDir [250];
	getcwd(keymapDir, sizeof(keymapDir));
	strcat(keymapDir, "/kbd/");

	struct dirent *entry;
	g_keymap_count = 0;
	char* fname;

	DIR* dir = opendir(keymapDir);

	while ( (entry = readdir(dir)) != NULL) 
	{
		if (strcmp(entry->d_name, ".") == 0 ||
			strcmp(entry->d_name, "..") == 0)
		{
			continue;
		}

		char *ext = strrchr(entry->d_name, '.');
		if (ext != NULL)
		{
			if ((stricmp(ext+1, "kbd") != 0))
			{
				continue;
			}
		}

		fname = (char*) calloc(260, sizeof(char));
		strcpy(fname, entry->d_name);
		g_keymap_list[g_keymap_count] = fname;
		g_keymap_count++;
	}
}

void PopulateFileList()
{
	char diskDir [250];
	getcwd(diskDir, sizeof(diskDir));

	strcat(diskDir, "/discs/");

	struct dirent *entry;
	g_rom_count = 0;
	char* fname;

	DIR* dir = opendir(diskDir);

	while ( (entry = readdir(dir)) != NULL) 
	{
		if (strcmp(entry->d_name, ".") == 0 ||
			strcmp(entry->d_name, "..") == 0)
		{
			continue;
		}

		char *ext = strrchr(entry->d_name, '.');
		if (ext != NULL)
		{
			if ((stricmp(ext+1, "ssd") != 0) &&
				(stricmp(ext+1, "dsd") != 0) &&
				(stricmp(ext+1, "adl") != 0) &&
				(stricmp(ext+1, "adf") != 0))
			{
				continue;
			}
		}
		else
		{
			continue;
		}

		fname = (char*) calloc(260, sizeof(char));
		strcpy(fname, entry->d_name);
		g_rom_list[g_rom_count] = fname;
		g_rom_count++;
	}
	closedir(dir);
}

int GetFullscreenState(void)
{
	return(fullscreen);
}

int ToggleFullscreen(void)
{
	if (fullscreen != 0)
		fullscreen = 0;
	else
		fullscreen = 1;

	Destroy_Screen();
	if (Create_Screen() != 1){
		qFATAL("Could not recreate SDL window!\n");
		exit(10);
	}

	/* Update GUI here so it's not missed anywhere - this is
	 * turning into such a bloody MESS...
	 */
	//XXX ClearWindowsBackgroundCacheAndResetSurface();

//	if (SDL_WM_ToggleFullScreen(screen_ptr) != 1)
//		EG_Log(EG_LOG_WARNING, dL"Could not toggle full-screen mode.", dR);

	return(fullscreen);
}

void UnfullscreenBeforeExit(void)
{
	/* Hopefully this will fix that annoying bug where the mouse pointer
	 * vanishes on exit.  Is that me, or is it SDL?
	 */
	if (fullscreen)
		ToggleFullscreen();
}

void ShowingMenu(void)
{
	showing_menu = 1;
}

void NoMenuShown(void)
{
	showing_menu = 0;
}

void Quit(void)
{
	done=1;
}


void LoadWhiteFont()
{
	char TmpPath[250];

	getcwd(TmpPath, sizeof(TmpPath));

	strcat(TmpPath, "/resources/menuWhiteFont.png");
	printf("loading %s\n", TmpPath);
	SDL_Surface* sur = SDL_DisplayFormat(IMG_Load(TmpPath));
	printf("surface = %d\n", sur);
	menuWhiteFont = SFont_InitFont(sur);
	
	SDL_Rect rect;
	SDL_BlitSurface(sur, NULL, screen_ptr,&rect);
	printf("whiteFont = %d\n", menuWhiteFont);
}

void LoadYellowFont()
{
	char TmpPath[250];
	getcwd(TmpPath, sizeof(TmpPath));

	strcat(TmpPath, "/resources/menuYellowFont.png");
	printf("loading %s\n", TmpPath);
	menuYellowFont = SFont_InitFont(SDL_DisplayFormat(IMG_Load(TmpPath)));
}

void LoadBanner()
{
	char TmpPath[250];
	getcwd(TmpPath, sizeof(TmpPath));
	strcat(TmpPath, "/resources/banner.png");
	banner = SDL_DisplayFormat(IMG_Load(TmpPath));
}

void DrawMenuBanner()
{
	SDL_BlitSurface(banner, NULL, screen_ptr, NULL);

	SFont_WriteCenter(screen_ptr, menuWhiteFont, 100, "GP2X Version 0.1.0");
}

void DrawKeymapLoaded()
{
	SDL_Rect rect;
	rect.x = 40;
	rect.y = 160;
	rect.w = 560;
	rect.h = 480 - rect.y;
	SDL_FillRect(screen_ptr, &rect, SDL_MapRGB(screen_ptr->format, 255, 255, 255));
	
	int border = 20;

	rect.x += border;
	rect.y += border;
	rect.w -= (2*border);
	rect.h -= (2*border);

	SDL_FillRect(screen_ptr, &rect, SDL_MapRGB(screen_ptr->format, 20, 20, 20));

	int xPos = 80;
	int yPos = 180;
	int descriptionXPos = 400;
	const int SPACING = 26;

	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "Keymap loaded:");
	yPos += 34;

	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "LEFT");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[0][1]));
	yPos += SPACING;
	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "RIGHT");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[1][1]));
	yPos += SPACING;
	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "UP");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[2][1]));
	yPos += SPACING;
	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "DOWN");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[3][1]));
	yPos += SPACING;
	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "A");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[4][1]));
	yPos += SPACING;
	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "B");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[5][1]));
	yPos += SPACING;
	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "X");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[6][1]));
	yPos += SPACING;
	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "Y");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[7][1]));
	yPos += SPACING;
	SFont_Write(screen_ptr, menuWhiteFont, xPos, yPos, "SELECT");
	SFont_Write(screen_ptr, menuWhiteFont, descriptionXPos, yPos, SDLKToKeyname(gp2x_mapping[8][1]));
}

void ClearEvents()
{
	SDL_Event event;
    SDL_Delay(333);
    while(SDL_PollEvent(&event))
	{
		SDL_Delay(50);
	}
}

void ClearScreen()
{
	SDL_Rect rect;
	rect.x = 0;
	rect.y = 0;
	rect.w = 640;
	rect.h = 480;
	SDL_FillRect(screen_ptr, &rect, SDL_MapRGB(screen_ptr->format, 0, 0, 0));
	SDL_UpdateRect(screen_ptr, 0, 0, 0, 0);
}

void DrawSelectionRect(SFont_Font* font, int x, int line, char* text)
{
	// write a grey block behind the selected item
	SDL_Rect bg_rect;

	bg_rect.x = x - 10;
	bg_rect.y = line + 2;
	bg_rect.w = SFont_TextWidth(font, text) + 20;
	bg_rect.h = SFont_TextHeight(font) - 2;
	SDL_FillRect(screen_ptr, &bg_rect, SDL_MapRGB(screen_ptr->format, 40, 40, 40));
}

void BlankDiskArea()
{
	SDL_Rect rect;
	rect.x = 0;
	rect.y = 360;
	rect.w = 640;
	rect.h = 100;
	SDL_FillRect(screen_ptr, &rect, SDL_MapRGB(screen_ptr->format, 0, 0, 0));
}

void BlankKeymapArea()
{
	SDL_Rect rect;
	rect.x = 250;
	rect.y = 160 + MENU_LINE_HEIGHT + MENU_LINE_HEIGHT;
	rect.w = 640-250;
	rect.h = 100;
	SDL_FillRect(screen_ptr, &rect, SDL_MapRGB(screen_ptr->format, 0, 0, 0));
}

void BlankOptionsArea()
{
	SDL_Rect rect;
	rect.x = 0;
	rect.y = 160;
	rect.w = 640;
	rect.h = 480 - rect.y;
	SDL_FillRect(screen_ptr, &rect, SDL_MapRGB(screen_ptr->format, 0, 0, 0));
}

void DrawMainMenu()
{
	int menuXPos = 10;
	int menuYPos = 160;
	SFont_Font* lineFont;
	SDL_Rect bg_rect;

	for (int i = 0; i < MENU_LINE_COUNT; i++)
	{
		lineFont = (i == g_selected_line) ? menuYellowFont : menuWhiteFont;

		if (i == MENU_LINE_SOUND)
		{
			SFont_Write(screen_ptr, lineFont, menuXPos, menuYPos, "Sound:");
			
			if (MenuSoundEnabled == 1)
			{
				DrawSelectionRect(lineFont, menuXPos + 240, menuYPos, "On");
			}
			else if (MenuSoundEnabled == 0)
			{
				DrawSelectionRect(lineFont, menuXPos + 240 + 100, menuYPos, "Off");
			}
			else if (MenuSoundEnabled == 2)
			{
				DrawSelectionRect(lineFont, menuXPos + 240 + 100 + 100, menuYPos, "Accurate");
			}

			SFont_Write(screen_ptr, lineFont, menuXPos + 240, menuYPos, "On");
			SFont_Write(screen_ptr, lineFont, menuXPos + 240 + 100, menuYPos, "Off");
			SFont_Write(screen_ptr, lineFont, menuXPos + 240 + 100 + 100, menuYPos, "Accurate");
		}
		else if (i == MENU_LINE_FRAMESKIP)
		{
			SFont_Write(screen_ptr, lineFont, menuXPos, menuYPos, "Frameskip:");

			int fs = mainWin->m_skip_max_frame;

			if (fs == 0)
			{
				DrawSelectionRect(lineFont, menuXPos + 240, menuYPos, "0");
			}
			else if (fs == 1)
			{
				DrawSelectionRect(lineFont, menuXPos + 240 + 80, menuYPos, "1");
			}
			else if (fs == 2)
			{
				DrawSelectionRect(lineFont, menuXPos + 240 + 80 + 80, menuYPos, "2");
			}
			else if (fs == 3)
			{
				DrawSelectionRect(lineFont, menuXPos + 240 + 80 + 80 + 80, menuYPos, "2");
			}

			SFont_Write(screen_ptr, lineFont, menuXPos + 240, menuYPos, "0");
			SFont_Write(screen_ptr, lineFont, menuXPos + 240 + 80, menuYPos, "1");
			SFont_Write(screen_ptr, lineFont, menuXPos + 240 + 80 + 80, menuYPos, "2");
			SFont_Write(screen_ptr, lineFont, menuXPos + 240 + 80 + 80 + 80, menuYPos, "3");
		}
		else if (i == MENU_LINE_KEYMAP)
		{
			SFont_Write(screen_ptr, lineFont, menuXPos, menuYPos, "Keymap:");
			SFont_Write(screen_ptr, lineFont, menuXPos + 240, menuYPos, g_keymap_list[g_selected_keymap_ix]);
		}
		else if (i == MENU_LINE_STATE)
		{
			SFont_Write(screen_ptr, lineFont, menuXPos, menuYPos, "State:");
			SFont_Write(screen_ptr, lineFont, menuXPos + 240, menuYPos, "Load");
			SFont_Write(screen_ptr, lineFont, menuXPos + 240 + 120, menuYPos, "Save");
		}
		else if (i == MENU_LINE_ROM_SELECTOR)
		{
			menuYPos += MENU_LINE_HEIGHT;
			SFont_Write(screen_ptr, lineFont, menuXPos, menuYPos, "Select disk then B to run:");
			menuYPos += MENU_LINE_HEIGHT;
			
			if (g_rom_list[g_selected_rom_ix] != NULL)
			{
				SFont_WriteCenter(screen_ptr, lineFont, menuYPos, g_rom_list[g_selected_rom_ix]);
			}
			else
			{
				SFont_WriteCenter(screen_ptr, lineFont, menuYPos, "No disks found");
			}
		}
		else if (i == MENU_LINE_QUIT)
		{
			SFont_Write(screen_ptr, lineFont, menuXPos, menuYPos, "Quit");
		}

		menuYPos += MENU_LINE_HEIGHT;
	}

	SDL_UpdateRect(screen_ptr, 0, 0, 0, 0);
}

int kbd_load_mapping_file(FILE *KbdFile)
{
	char     Buffer[512];
	char    *Scan;
	char	*sdlkName;
	
	while (fgets(Buffer,512,KbdFile) != (char *)0) 
	{
		
		Scan = strchr(Buffer,'\n');
		if (Scan) *Scan = '\0';
		/* For this #@$% of windows ! */
		Scan = strchr(Buffer,'\r');
		if (Scan) *Scan = '\0';
		if (Buffer[0] == '#') continue;
		
		Scan = strchr(Buffer,'=');
		if (! Scan) continue;
		
		*Scan = '\0';
		sdlkName = Scan + 1;
		
		int gp2xButtonNum = buttonnameToGP2XButton(Buffer);
		//printf ("gp2x = %s, sdlk = %s\n", Buffer, sdlkName);
		int sdlk = keynameToSDLK(sdlkName);
		apply_mapping(gp2xButtonNum, sdlk);
	}
	
	return 0;
}

int kbd_load_mapping(char *kbd_filename)
{
	FILE    *KbdFile;
	int      error = 0;
	
	KbdFile = fopen(kbd_filename, "r");
	error   = 1;
	
	if (KbdFile != (FILE*)0) 
	{
		kbd_load_mapping_file(KbdFile);
		error = 0;
		fclose(KbdFile);
	}
    
	return error;
}




//------------------------------------------------

//-- int CALLBACK WinMain(HINSTANCE hInstance, 
//-- 					HINSTANCE hPrevInstance,
//-- 					LPSTR lpszCmdLine,
//-- 					int nCmdShow)
//-- { 
int main(int argc, char *argv[]){

	gp2x_init();
	gp2x_set_cpu_speed(250);

	/* Create global reference to command line args (like windows does)
	 */
	__argc = argc;
	__argv = (char**) argv;


	/* Initialise debugging subsystem.
	 */
	Log_Init();

	/* Initialize SDL resources.
	 */
	if (! InitialiseSDL(argc, argv)){
		qFATAL("Unable to initialise SDL library!");
		exit(1);
	}

	LoadWhiteFont();
	LoadYellowFont();
	LoadBanner();
	
	PopulateFileList();
	PopulateKeymapList();

	InitializeFakeRegistry();

	// Create instance of Emulator core:
	mainWin=new BeebWin();
	mainWin->Initialise();

	beeb_default_settings();

	// load default.kbd mappings
	char MapName [250];
	strcpy(MapName, "kbd/default.kbd");

	kbd_load_mapping(MapName);
	DrawMenuBanner();
	DrawMainMenu();

	SDL_ShowCursor(SDL_DISABLE);

	done = 0; 

	SDL_Event event;

	if (argc == 1)
	{
		showing_menu = 1;
	}

	do
	{
		/* Toggle processing of either events to the emulator core, or events to the menu.
		 */
		

		if (showing_menu != 1)
		{

		/* Execute emulator:
		 */

		if (!mainWin->IsFrozen())
			Exec6502Instruction();

		while (SDL_PollEvent(&event))
			switch (event.type)
			{
			case SDL_QUIT:
				done=1;
			break;


			case SDL_JOYBUTTONDOWN:
			case SDL_JOYBUTTONUP:
				{
					// Reset shift state if it was set by Run Disc
					if (mainWin->m_ShiftBooted)
					{
						mainWin->m_ShiftBooted = false;
						BeebKeyUp(0, 0);
					}

					int pressed=0, col=0, row=0;
					//SDL_keysym keysym;
					int keysym = 0;
					//keysym.sym = SDLK_UNKNOWN;
					if (event.jbutton.button == GP2X_BUTTON_START)
					{
						// back to menu - freeze
						mainWin->Focus(false);
						showing_menu = 1;
						ClearScreen();
						DrawMenuBanner();
						DrawMainMenu();
						ClearEvents();
					}
					else if (event.jbutton.button == GP2X_BUTTON_LEFT ||
							event.jbutton.button == GP2X_BUTTON_RIGHT ||
							event.jbutton.button == GP2X_BUTTON_UP ||
							event.jbutton.button == GP2X_BUTTON_DOWN ||
							event.jbutton.button == GP2X_BUTTON_A ||
							event.jbutton.button == GP2X_BUTTON_B ||
							event.jbutton.button == GP2X_BUTTON_X ||
							event.jbutton.button == GP2X_BUTTON_Y ||
							event.jbutton.button == GP2X_BUTTON_SELECT)
					{
						//printf("about to do sdlk lookup %d\n", event.jbutton.button);
						keysym = gp2xButtonToSDLK(event.jbutton.button);

						//keysym.sym = SDLK_z;
						if (ConvertSDLKeyToBBCKey(keysym, &col, &row))
						{
							if (event.type == SDL_JOYBUTTONDOWN)
								BeebKeyDown(row, col);
							else
								BeebKeyUp(row, col);
						}
					}

					if (keysym != 0)
					{
						/* Handle reset:
						 */
						if(row==-2)
						{ // Must do a reset!
							Init6502core();

							Enable_Z80 = 0;
							
							Disc8271_reset();
							Reset1770();
							SCSIReset();
							SASIReset();
							TeleTextInit();
							//SoundChipReset();
						}
					}
				}
				break;
			}
		
		}
		else
		{
			//DrawMainMenu();

			while ( SDL_PollEvent(&event) )
			{
				switch (event.type)
				{
					case SDL_QUIT:
						done=1;
					break;

					case SDL_JOYBUTTONDOWN:
					case SDL_JOYBUTTONUP:
					{
						if (event.jbutton.button == GP2X_BUTTON_LEFT)
						{
							if (g_selected_line == MENU_LINE_SOUND)
							{
								printf("left\n");
								if (MenuSoundEnabled == 0)
								{
									MenuSoundEnabled = 1;
									cfg_WantLowLatencySound = 0;
									mainWin->SetSoundEnabled(1);
								}
								else if (MenuSoundEnabled == 2)
								{
									MenuSoundEnabled = 0;
									cfg_WantLowLatencySound = 0;
									mainWin->SetSoundEnabled(0);
								}

								BlankOptionsArea();
								DrawMainMenu();

							}
							else if (g_selected_line == MENU_LINE_FRAMESKIP)
							{
								int fs = mainWin->m_skip_max_frame;
								if (fs > 0)
								{
									fs--;
								}
								mainWin->m_skip_max_frame = fs;
								mainWin->m_skip_cur_frame = 0;
								BlankOptionsArea();
								DrawMainMenu();
							}
							else if (g_selected_line == MENU_LINE_KEYMAP)
							{
								if (g_selected_keymap_ix > 0)
								{
									g_selected_keymap_ix --;
									BlankKeymapArea();
								}
							}
							else if (g_selected_line == MENU_LINE_STATE)
							{
								// XXX hover over load/save state
							}
							else if (g_selected_line == MENU_LINE_ROM_SELECTOR)
							{
								// 
								if (g_selected_rom_ix > 0)
								{
									g_selected_rom_ix --;
									BlankDiskArea();
								}
							}
						}
						else if (event.jbutton.button == GP2X_BUTTON_RIGHT)
						{
							if (g_selected_line == MENU_LINE_SOUND)
							{
								if (MenuSoundEnabled == 0)
								{
									MenuSoundEnabled = 2;
									cfg_WantLowLatencySound = 1;
									mainWin->SetSoundEnabled(1);
								}
								else if (MenuSoundEnabled == 1)
								{
									MenuSoundEnabled = 0;
									cfg_WantLowLatencySound = 0;
									mainWin->SetSoundEnabled(1);
								}

								BlankOptionsArea();
								DrawMainMenu();
							}
							else if (g_selected_line == MENU_LINE_FRAMESKIP)
							{
								// set frameskip
								int fs = mainWin->m_skip_max_frame;
								if (fs < 3)
								{
									fs++;
								}
								mainWin->m_skip_max_frame = fs;
								mainWin->m_skip_cur_frame = 0;
								BlankOptionsArea();
								DrawMainMenu();
							}
							else if (g_selected_line == MENU_LINE_KEYMAP)
							{
								if (g_selected_keymap_ix < g_keymap_count - 1)
								{
									g_selected_keymap_ix ++;
									BlankKeymapArea();
								}
							}
							else if (g_selected_line == MENU_LINE_STATE)
							{
								// XXX hover over load/save state
							}
							else if (g_selected_line == MENU_LINE_ROM_SELECTOR)
							{
								if (g_selected_rom_ix < g_rom_count - 1)
								{
									g_selected_rom_ix ++;
									BlankDiskArea();
								}
							}
						}
						else if (event.jbutton.button == GP2X_BUTTON_UP)
						{
							if (g_selected_line == 0)
							{
								g_selected_line = MENU_LINE_COUNT - 1;
							}
							else
							{
								g_selected_line--;
							}
						}
						else if (event.jbutton.button == GP2X_BUTTON_DOWN)
						{
							if (g_selected_line == MENU_LINE_COUNT - 1)
							{
								g_selected_line = 0;
							}
							else
							{
								g_selected_line++;
							}
						}
						else if (event.jbutton.button == GP2X_BUTTON_B)
						{
							if (g_selected_line == MENU_LINE_KEYMAP)
							{
								// load the currently-selected keymap
								char MapName [250];
								strcpy(MapName, "kbd/");
								strcat(MapName, g_keymap_list[g_selected_keymap_ix]);

								kbd_load_mapping(MapName);
								BlankOptionsArea();
								DrawKeymapLoaded();
								SDL_Delay(3000);
								BlankOptionsArea();
								DrawMainMenu();
								printf("loaded keymap: %s\n", MapName);
							}

							else if (g_selected_line == MENU_LINE_ROM_SELECTOR)
							{
								if (g_rom_count > 0)
								{
									char DiskName [250];

									strcpy(DiskName, "discs/");
									strcat(DiskName, g_rom_list[g_selected_rom_ix]);
									showing_menu = 0;

									// hey ho, let's go
									mainWin->HandleFile(DiskName);
									showing_menu = 0;
									ClearScreen();
									if (mainWin->IsFrozen())
										mainWin->Focus(true);
								}
							}
							else if (g_selected_line == MENU_LINE_QUIT)
							{
								// we're out of there
								done = 1;
							}
						}
						else if (event.jbutton.button == GP2X_BUTTON_START)
						{
							//thaw 
							showing_menu = 0;
							ClearScreen();
							if (mainWin->IsFrozen())
								mainWin->Focus(true);

						}


						if (showing_menu)
							DrawMainMenu();

						ClearEvents();
					}
				}
				//SDL_Delay(200);
			}
			SDL_Delay(10);
			
		}
	} while(done==0);


	delete mainWin;

	/* Cleanly free SDL and logging.
	 */
#ifdef WITH_DEBUG_OUTPUT
	DumpFakeRegistry();
#endif

	DestroyFakeRegistry();
	UninitialiseSDL();
	Log_UnInit();

	gp2x_quit();
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
	return(0);  
}
